/*
 * @Author: your name
 * @Date: 2020-06-19 16:41:51
 * @LastEditTime: 2020-06-19 16:42:20
 * @LastEditors: Please set LastEditors
 * @Description: In User Settings Edit
 * @FilePath: \dva-jingzi-game\src\component\box.js
 */
import styled from 'styled-components';
import WinImg from './winImg';
const Box = styled.div `
  background: #fff;
  border: 1px solid #999;
  float: left;
  font-size: 24px;
  font-weight: bold;
  line-height: 100px;
  height: 100px;
  padding: 5px;
  text-align: center;
  width: 100px;
`

function BoxMaster(props) {
    const handelClick = (value) => {
        // 判断游戏是否有胜利者
        if (props.winner) return
            // 判断是否重复点击
        if (!reClick(value)) {
            // 更新整体
            props.dispatch({
                    type: 'main/updateObjFn',
                    id: value.value,
                    flag: value.nowFliage,
                })
                // 保存每一步操作
            console.log("11");

            props.dispatch({
                type: 'main/saveActionFn',
                id: value.value,
                flag: value.nowFliage,
            })
        }
    }

    // 是否重复点击
    function reClick(value) {
        let tempObj = value.datasource.find((item, index) => {
            return item.value === value.value
        })
        if (tempObj && tempObj.flag) {
            return true
        } else {
            return false
        }
    }


    return ( <
        Box onClick = {
            () => handelClick(props)
        }
        style = {
            { background: props.winner && props.value === props.winner.value ? "" : props.color }
        } > {
            props.winner && props.value === props.winner.value ? ( <
                WinImg flag = { props.flag }
                />
            ) : ( < span > { props.flag } < /span>)

                } <
                /Box>
        )
    }

    export default BoxMaster